/*SpUpd!_2019.04.23_0000725*/
/*needVer=2019.04.08_0000724*/


CREATE INDEX SPR_SPECIALITY_IDX1
ON SPR_SPECIALITY (CODE_SPEC,DATEBEG,DATEEND)
@

CREATE OR ALTER procedure SP_CONV_DBFTOXML (
    REPN integer)
as
declare variable ID_ILL integer;
declare variable NEW_BED smallint;
declare variable TS smallint;
declare variable MISH smallint;
declare variable KS_RES smallint;
declare variable DS_RES smallint;
declare variable RSLT smallint;
declare variable ID integer;
declare variable NOV smallint;
declare variable MP smallint;
declare variable SPEC smallint;
declare variable VER varchar(10);
declare variable NOM_MTL smallint;
declare variable USL_ID integer;
begin
  for select M.ID, S.ID_ILL, M.NOM_MTL, SP.CODE_SPEC, SP.VERS_SPEC, L.NEW_BED,
             iif(M.RES_LECHEN < 5, M.RES_LECHEN, iif(M.RES_LECHEN = 5, 1, 4)) MISH, iif(R.TIP_STAC = 1, 1, 2) TS,
             I.IDRMP_KS, I.IDRMP_DS, PB.ID_MP --iif(r.oplat=1 and (r.lpu in (57,115,117,127)) and pb.id_mp=136,137,pb.id_mp)
      from MTL M
      join STACION S on S.ID_ILL = M.ID_ILL
      join REPORTS R on R.REPN = S.REPN
      join LST_KOIKI L on L.TIP = M.PROFILE and
            L.DATEBEG <= S.OUT_STAC and
            (L.DATEEND >= S.OUT_STAC or (L.DATEEND is null))
      join PROFIL_BED PB on PB.BED_ID = L.NEW_BED and
            PB.OLD_BED = M.PROFILE and
            PB.DATEBEG <= S.OUT_STAC and
            (PB.DATEEND >= S.OUT_STAC or (PB.DATEEND is null))
      join ISHOD_LECE I on I.MYKEY = iif(M.RES_LECHEN = 6, 9, M.ISHOD_LECE)
      left join SPR_SPECIALITY SP on SP.STAC_CODE = M.VR_SPEC and
            (R.DATE_BEG between SP.DATEBEG and coalesce(SP.DATEEND, '31.12.9999'))
      where R.REPN = :REPN
      into :ID, :ID_ILL, :NOM_MTL, :SPEC, :VER, :NEW_BED, :MISH, :TS, :KS_RES, :DS_RES, :MP
  do
  begin
    if (TS = 1) then
      RSLT = KS_RES;
    else
      RSLT = DS_RES;

    update MTL M set M.RSLT = :RSLT, M.ISHOD = (:MISH + :TS * 100), M.PROFIL_BED = :NEW_BED, M.PR_FED = :MP
    where M.ID = :ID;

    update MTL M set M.PRVS = :SPEC, M.VERS_SPEC = :VER
    where (M.ID = :ID) and (:SPEC is not null); -- / AMV 26.06.2018 / convert from vr_spec to prvs

    if (SPEC is not null) then
      begin
      for select O.ID from OPERAT O
      where O.ID_ILL = :ID_ILL and O.NOM_MTL = :NOM_MTL
      into :USL_ID do
        begin
        update OPERAT O set O.PRVS = :SPEC
        where O.ID = :USL_ID;
        end
      end
  end

  for select distinct S.ID_ILL, iif(S.SRES_LECHEN < 5, S.SRES_LECHEN, iif(S.SRES_LECHEN = 5, 1, 4)) SISH,
                      iif(R.TIP_STAC = 1, 1, 2) TS, I.IDRMP_KS, I.IDRMP_DS, iif(S.NOVOR is null, 1, 0)
      from MTL M
      join STACION S on S.ID_ILL = M.ID_ILL
      join REPORTS R on R.REPN = S.REPN
      join ISHOD_LECE I on I.MYKEY = iif(S.SRES_LECHEN = 6, 9, S.SISHOD_LECE)
      where R.REPN = :REPN
      into :ID_ILL, :MISH, :TS, :KS_RES, :DS_RES, :NOV
  do
  begin
    if (TS = 1) then
      RSLT = KS_RES;
    else
      RSLT = DS_RES;
                    
    update STACION S set S.RSLT = :RSLT, S.ISHOD = (:MISH + :TS * 100)
    where S.ID_ILL = :ID_ILL;

    if (NOV = 1) then
      update STACION S set S.NOVOR = 0 where S.ID_ILL = :ID_ILL;
  end
  suspend;
end;
@

update spr_ksg k set k.dend = '31.03.2019' where k.ksg_id = 'st03.001' and k.dbeg = '01.01.2019';
@
insert into spr_ksg
    select k.ksg_id, k.name, k.kz, k.kz2, k.prof, k.ts, '01.04.2019', null, k.rec_ksg, 1, k.ovlong, k.gr, k.sgr, k.oplat, k.is_hir_ksg
    from spr_ksg k
    where k.ksg_id = 'st03.001' and k.dbeg = '01.01.2019';
@